# TAMING TIME - MODELLING UNCERTAINTY AS REPRODUCIBLE LINKED OPEN DATA

## EAA 2018, Abstract 3358

**Florian Thiery<sup>1,3</sup> AND Dr. Allard Mees<sup>2,3</sup>**

<sup>1</sup> Florian Thiery M.Sc. `thiery@rgzm.de` <a href="https://orcid.org/0000-0002-3246-3531" target="orcid.widget" rel="noopener noreferrer" style="vertical-align:top;"><img src="https://orcid.org/sites/default/files/images/orcid_16x16.png" style="width:1em;margin-right:.5em;" alt="ORCID iD icon">orcid.org/0000-0002-3246-3531</a>

<sup>2</sup> Dr. Allard Mees FSA `mees@rgzm.de`

<sup>3</sup> Römisch-Germanisches Zentralmuseum Mainz, Leibniz-Forschungsinstitut für Archäologie [`rgzm.de`](http://rgzm.de/), Kompetenzbereich Wissenschaftliche IT

**keywords**: `Linked Open Data`, `Chronology` `Samian` `Sigillata` `Allens's Alegebra`

It is a stroke of luck that the RGZM (Römisch-Germanisches Zentralmuseum Mainz) hosts already since the mid-1990s several online available databases containing millions of datasets, with content from many different archaeological disciplines. These databases where constructed in interdisciplinary transnational projects and include a lot of “hidden archaeological assumptions” in their relational data models. Especially short cutted relative chronological information and its dependencies are not modelled using transparent methods. The aim of our project is to make these hidden assumptions in archaeology visible and provide them as Linked Open Data to establish reproducible research as a fundament for Open Science.

In particular the Samian Research database at the RGZM offers nearly 250'000 identified potter stamps, which are traditionally dated in a short cutted way. In Roman archaeology this is usually expressed by establishing "absolute dates" in well known “from-to” tables, whereas in reality, the situation is much more diffuse. In fact, Limes fortress dating is often done based on circular arguments. Samian stamps, for example, are being dated by sites, which on their own are again being dated by Samian.

This paper focuses on modelling these circular dating arguments using a relative chronology based on Allen’s interval algebra for temporal reasoning in the Academic Meta Tool (AMT) to create Linked Open Data for reproducible and transparent research. AMT allows us to create a fitting ontology and visualise the reasoning results in a web app for detecting errors and circular reasoning. As an example, we will take a deeper look into the relative chronological relationships of the Limes fortresses.

## Presentation

[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.abc.svg)](https://doi.org/10.5281/zenodo.abc)

## Live Demo

[![Demo](https://img.shields.io/badge/demo-amt--eaa2018-brightgreen.svg?style=flat)](http://academic-meta-tool.xyz/eaa2018/)

## Links

[![info](https://img.shields.io/badge/amt--eaa2018-git repo-orange.svg?style=flat)](https://github.com/RGZM/amt-eaa2018)

[![info](https://img.shields.io/badge/Academic Meta Tool-website-yellowgreen.svg?style=flat)](http://www.academic-meta-tool.xyz)
[![info](https://img.shields.io/badge/Academic Meta Tool-git repo-yellowgreen.svg?style=flat)](https://github.com/AcademicMetaTool/amt)

[![info](https://img.shields.io/badge/Samian Research-database-yellow.svg?style=flat)](http://rgzm.de/samian)

{% include footer.htm %}
